#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#ifdef USE_GNOME
#      include <gnome.h>
#      include <zvt/zvtterm.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "data.h"
#include "xtext.h"
#define ADD 1
#define MISC 0

/*generales*/
extern gboolean   state; /*estadp run or stop*/
extern gboolean   que; /*word o watcher*/
extern gboolean bxtext;
extern GtkWidget *item_word; /* tiene el puntero al item word seleccionado */

extern GtkWidget *item_actual;        /* mantienen puntero al item tree \
                                       seleccionado y a su subree*/
extern GtkWidget *item_actual_subtree;
extern watcher   *punta;
extern gdouble    color_add[3];

/******MISC*************/
extern gdouble color_m[3]; 
extern GtkWidget *m_t_color;
extern gboolean bzvt;
extern gboolean btint;

extern gint      mess_id;
extern gint      tag; /*tag del timeout*/

/*window1*/
extern GtkWidget *window1;
extern GtkWidget *text1;
extern GtkWidget *statusbar1;
extern GtkWidget *m_check_tint;
extern GtkWidget *m_check_zvt;
/*w_cofig*/
extern GtkWidget *w_config;
extern GtkWidget *tree1;

extern GtkWidget *e_path;
extern GtkWidget *e_color;
extern GdkFont *fixed_font;
gboolean status=FALSE;

extern gint w1_altura;
extern gint w1_ancho;
extern gint xw1;
extern gint yw1;

extern gint wc_altura;
extern gint wc_ancho;

extern GtkWidget *m_hbox2;
extern gchar *ufont;

extern GdkColor xcolors[];

extern GtkWidget *filesel;
extern GtkWidget *fontsel;
extern GtkWidget *add;
extern GtkWidget *add_word;
extern GtkWidget *colorsel;
void
on_b_save_clicked ()
{

    if(status==TRUE)
    {
        GtkWidget *button;
        gpointer *id;
        if(filesel==NULL)
        {
            filesel=create_fileselection1();
            button=GTK_WIDGET(gtk_object_get_data (GTK_OBJECT(filesel),"ok_button2"));

            GPOINTER_TO_INT(id)=gtk_object_get_data (GTK_OBJECT(filesel),"id");

            gtk_signal_disconnect (GTK_OBJECT(button), GPOINTER_TO_INT(id));


            gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filesel)->ok_button), "clicked",
                                GTK_SIGNAL_FUNC (guardar),
                                GTK_OBJECT(filesel));
            gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filesel)->ok_button), "clicked",
                                GTK_SIGNAL_FUNC (destroy_files),
                                NULL);

            gtk_widget_show(filesel);
        }
        else gdk_window_raise(filesel->window);
    }
}



void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{

    on_b_quit_clicked(NULL,NULL);
    
}


void
on_b_start_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    watcher *temp=punta;

    if(status!=TRUE)
    {
        status=TRUE;
        while(temp!=NULL)
        {
            temp->fp=fopen(temp->path,"r");
            if (temp->fp!=NULL)
            {
                fseek(temp->fp,-1,SEEK_END);
#ifdef  DEBUG
                g_print("archivo abierto %s\n",temp->path);
#endif
            }
#ifdef  DEBUG
            else g_print("archivo: %s no se abrio",temp->path);
#endif
            temp=temp->next;
        gtk_statusbar_pop(GTK_STATUSBAR(statusbar1),mess_id);
        gtk_statusbar_push(GTK_STATUSBAR(statusbar1),mess_id,_("The Selected file are beeing watched for words!"));
        tag=gtk_timeout_add(10,(GtkFunction) update,NULL);
        }
    }
}


void
on_b_stop_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
    watcher *temp=punta;
    if(status!=FALSE)
    {
        status=FALSE;
        gtk_timeout_remove( tag );
        while(temp!=NULL)
        {
            fclose(temp->fp);
#ifdef  DEBUG
            g_print("archivo Cerrado %s\n",temp->path);
#endif
            temp=temp->next;
        }

        gtk_statusbar_pop(GTK_STATUSBAR(statusbar1),mess_id);
        gtk_statusbar_push(GTK_STATUSBAR(statusbar1),mess_id,_("Thers's no files beeing watched right now!"));
    }
}

/*---------------------------CONFIGURE----------------------------------*/

void
on_b_configure_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
    if(status!=FALSE)
    {
        GtkWidget *window,*label,*button;
        window=gtk_dialog_new();
        button =gtk_button_new_with_label ("OK");
        gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->action_area),
                            button, TRUE, TRUE, 0);
        gtk_signal_connect_after (GTK_OBJECT (button), "clicked",
                                  (GtkSignalFunc) gtk_widget_destroy,
                                  GTK_WIDGET(window));
        gtk_widget_show (button);
        label = gtk_label_new (_(" The Watcher is running please \nstop it first "));
        gtk_box_pack_start (GTK_BOX (GTK_DIALOG (window)->vbox),
                            label, TRUE, TRUE, 0);
        gtk_widget_show(label);

        gtk_widget_show(window);
    }
    else gtk_widget_show(w_config);
}


                  /*--------------------------ADD-------------------*/
void
on_b_add_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    if(add==NULL)
    {
        add=create_w_add();
        gtk_widget_show(add);
    }
    else gdk_window_raise(add->window);
}

void
on_b_add_word_clicked()
{
    if(add_word==NULL)
    {
        add_word=create_w_add_word();
        gtk_widget_show(add_word);
    }
    else gdk_window_raise(add_word->window);
}


void
on_b_brow_path_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

    if(filesel==NULL)
    {
        filesel=create_fileselection1();
        gtk_widget_show(filesel);
    }
    else gdk_window_raise(filesel->window);

}

void
on_b_filesel_ok_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

    gtk_entry_set_text (GTK_ENTRY (e_path), gtk_file_selection_get_filename (GTK_FILE_SELECTION (user_data)) );
    destroy_files();
}

void
on_b_color_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
    if(colorsel==NULL)
    {
        colorsel=create_colorselectiondialog1 (ADD);
        gtk_widget_show(colorsel);
    }
    else gdk_window_raise(colorsel->window);

}
void
on_b_colorsel_ok_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{   GdkColormap  *cmap;
    GdkColor     colour;
    gchar        *text=_("Selected Color");
    gpointer bandera;

    GPOINTER_TO_INT(bandera)=gtk_object_get_data (GTK_OBJECT(user_data),"bandera");
    

    cmap = gdk_colormap_get_system();

    if(GPOINTER_TO_INT(bandera)==ADD)
    {
        gtk_color_selection_get_color (user_data,color_add);
        colour.red = (guint16)(color_add[0]*65535.0);
        colour.green = (guint16)(color_add[1]*65535.0);
        colour.blue = (guint16)(color_add[2]*65535.0);

        gtk_text_backward_delete(\
                            GTK_TEXT(e_color),gtk_text_get_length(GTK_TEXT(e_color))\
                           );

        gtk_text_insert (GTK_TEXT (e_color), NULL, &colour, NULL,
                         text, -1);
    }
    else
    {
        gtk_color_selection_get_color (user_data,color_m);
        colour.red = (guint16)(color_m[0]*65535.0);
        colour.green = (guint16)(color_m[1]*65535.0);
        colour.blue = (guint16)(color_m[2]*65535.0);
        gdk_color_alloc(cmap, &colour);
        gtk_text_backward_delete(\
                            GTK_TEXT(m_t_color),gtk_text_get_length(GTK_TEXT(m_t_color))\
                           );

        gtk_text_insert (GTK_TEXT (m_t_color), NULL, &colour, NULL,
                         text, -1);
        xcolors[0].pixel=colour.pixel;
        xcolors[0].red  =colour.red;
        xcolors[0].green=colour.green;
        xcolors[0].blue =colour.blue;
        if (bxtext==TRUE) gtk_xtext_set_palette ((GtkXText*) text1,xcolors);
    }
    destroy_colors();
}

void
on_b_ok_add_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
    gchar *path;
    GdkColor tcolor;
        if (color_add[0]!=-1 && strlen( gtk_entry_get_text(GTK_ENTRY(e_path) ))!=0 )
        {

            path=g_malloc0(strlen(gtk_entry_get_text(GTK_ENTRY(e_path)))+1);
            strcpy(path,gtk_entry_get_text(GTK_ENTRY(e_path)));
//#ifdef  DEBUG
            g_print("path: %s\n",path);
//#endif
            tcolor.red = (guint16)(color_add[0]*65535.0);
            tcolor.green = (guint16)(color_add[1]*65535.0);
            tcolor.blue = (guint16)(color_add[2]*65535.0);

            add_watcher(path,0,NULL,tcolor);
            add_watcher_tree(path);

        //    add_watcher_tree(path);
        }
#ifdef  DEBUG
        else g_print("Color o path no elegido\n");
#endif
        destroy_wadd();
}




                  /*-----------------------DEL-----------------------*/

void
on_b_del_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ /*
    if(state==FALSE)
    {
        //tenemos un watcher, borrar todo el watcher del p_philez;
        //borrar la linea en el tree
    }
    else
    {
        //tenemos un word, buscarla en el watcher y borrarla
        //borrar la linea en el tree

        }*/

    GtkWidget *owner;
    GtkLabel *label;
    gchar    *name;
    watcher  *temp;
    if(que==FALSE)
    {
        label = GTK_LABEL (GTK_BIN (item_actual)->child);
        gtk_label_get (label, &name);

        watcher_borrar(name);

        gtk_widget_ref (tree1);
        owner = GTK_TREE(tree1)->tree_owner;
        gtk_container_remove (GTK_CONTAINER(tree1), item_actual);
        if (tree1->parent == NULL)
        {
            gtk_tree_item_expand (GTK_TREE_ITEM(owner));
            gtk_tree_item_set_subtree (GTK_TREE_ITEM(owner), tree1);
        }
        else  gtk_widget_unref (tree1);
#ifdef  DEBUG
        g_print("borrado item_actual osea un WATCHER\n");
#endif



    }
    else
    {
        label = GTK_LABEL (GTK_BIN ( GTK_TREE(item_word->parent)->tree_owner   )->child);
        gtk_label_get (label, &name);
#ifdef  DEBUG
        g_print("parent path: %s\n",name);
#endif
        temp=watcher_find(name);
        if (temp!=NULL)
        {
            label = GTK_LABEL (GTK_BIN (item_word)->child);
            gtk_label_get (label, &name);
            word_borrar(temp,name);
        }
#ifdef  DEBUG
        else g_print("Wactcher no encontrado");
#endif
        gtk_container_remove (GTK_CONTAINER(GTK_TREE (item_word->parent)), item_word);
#ifdef  DEBUG
        g_print("borrado un item_word osea un WORD\n");
#endif
    }

}


void
on_b_quit_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
    on_b_stop_clicked(NULL,NULL);
    if(window1->window!=NULL)
    {
        gdk_window_get_size(window1->window,&w1_ancho,&w1_altura);
        gdk_window_get_position(window1->window,&xw1,&yw1);
    }

    if (w_config->window!=NULL)
        gdk_window_get_size(w_config->window,&wc_ancho,&wc_altura);

    save_config();
    g_print("TERMINO\n");

    gtk_exit(0);
}

void
on_b_ok_add_word_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
    watcher   *donde=NULL;
    GtkLabel *label;
    gchar    *name;
    gchar    *word;

    word=gtk_entry_get_text(GTK_ENTRY(user_data));

    if(strlen(word)!=0 && punta!=NULL)
    {
        add_word_tree(word);

        label = GTK_LABEL (GTK_BIN (item_actual)->child);
        gtk_label_get (label, &name);

        donde=watcher_find(name);
        add_word_struct(donde,word);

#ifdef  DEBUG
        if (donde==NULL)
        {
            g_print("ERROR");
            g_print("name: %s word: %s\n", name, word);
        }
        else
            g_print("Insertado name: %s word: %s\n", name, word);
#endif
    }
    destroy_addword();
}
/************************** MISC CALLBACKS**********************/

void on_mb_color_clicked()
{
    if(colorsel==NULL)
    {
        colorsel=create_colorselectiondialog1 (MISC);
        gtk_widget_show(colorsel);
    }
    else gdk_window_raise(colorsel->window);
}

void on_mb_zvt_clicked (GtkButton       *button,
                        gpointer         user_data)
{
if (GTK_TOGGLE_BUTTON (GTK_WIDGET(user_data))->active)
        {
            bzvt=TRUE;
            /* If control reaches here, the toggle button is down */
        
        } else
        {
            bzvt=FALSE;
            /* If control reaches here, the toggle button is up */
        }

#ifdef USE_IMLIB
            gtk_widget_set_sensitive (m_check_tint, bzvt);
#endif
            gtk_widget_set_sensitive (m_hbox2, bzvt);

}
void on_mb_tint_clicked (GtkButton       *button,
                        gpointer         user_data)
{
    if (GTK_TOGGLE_BUTTON (GTK_WIDGET(user_data))->active)
        {
            btint=TRUE;
            /* If control reaches here, the toggle button is down */

        } else {
            btint=FALSE;
            /* If control reaches here, the toggle button is up */
        }
    if(text1!=NULL)
    {
        if(text1!=NULL && bxtext)
        {
#ifdef USE_IMLIB
            gtk_xtext_set_background((GtkXText*) text1,(void *)-1,btint);
            gtk_widget_queue_draw (GTK_WIDGET(text1));
            gtk_widget_queue_draw (GTK_WIDGET(text1));
#endif
        }

        g_print("flag");
    }
}


void on_mb_font_clicked (GtkButton       *button,
                        gpointer         user_data)
{
    if(fontsel==NULL)
    {
        fontsel=create_fontselectiondialog1 (user_data);
        gtk_widget_show(fontsel);
    }
    else gdk_window_raise(fontsel->window);

}
void
font_selection_ok (GtkWidget              *w,
                   GtkFontSelectionDialog *fs)
{
    GtkWidget *text=gtk_object_get_data(GTK_OBJECT(fs),"text");

    if (ufont!=NULL)
    {
        g_free (ufont);
        ufont=NULL;
    }
    ufont = gtk_font_selection_dialog_get_font_name (fs);
    if(!bzvt)
    {
        gdk_font_unref(fixed_font);
        fixed_font = gdk_font_load (ufont);
    }
    else  gtk_xtext_set_font((GtkXText*) text1,fixed_font,ufont);

    gtk_text_backward_delete(GTK_TEXT(text),gtk_text_get_length(GTK_TEXT(text)));
    gtk_text_insert(GTK_TEXT (text), fixed_font , NULL, NULL , _("Selected Font"), -1);

    destroy_fonts();

}
void destroy_wadd()
{
    gtk_widget_destroy(add);
    add=NULL;
}
void destroy_colors()
{
    gtk_widget_destroy(colorsel);
    colorsel=NULL;
}
void destroy_files()
{
    gtk_widget_destroy(filesel);
    filesel=NULL;
}
void destroy_addword()
{
    gtk_widget_destroy(add_word);
    add_word=NULL;
}
void destroy_fonts()
{
    gtk_widget_destroy(fontsel);
    fontsel=NULL;
}