#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include "data.h"
#include "xtext.h"
extern gboolean   status; /*estadp run or stop*/
extern gboolean   que; /*word o watcher*/
extern gboolean   bxtext;
extern GtkWidget *item_word; /* tiene el puntero al item word seleccionado */

extern GtkWidget *item_actual;        /* mantienen puntero al item tree \
                                       seleccionado y a su subree*/
extern GtkWidget *item_actual_subtree;
extern watcher   *punta;
extern gdouble    color_add[3];

extern gint      mess_id;
extern gint      tag; /*tag del timeout*/

extern GtkWidget *w_config;
extern GtkWidget *tree1;
extern GtkWidget *text1;
extern GtkWidget *window1;

extern gint w1_altura;
extern gint w1_ancho;
extern gint xw1;
extern gint yw1;

extern gint wc_altura;
extern gint wc_ancho;
extern GtkWidget *m_check_tint;
extern GtkWidget *m_check_zvt;
extern gboolean bzvt;
extern gboolean btint;
extern gchar *ufont;

extern GdkFont *fixed_font;
extern GtkWidget *m_hbox2;
extern GdkColor xcolors[];
void
guardar (GtkObject       *object,
         gpointer         user_data)
{
    FILE *fh;
    gchar *save=NULL;
    gchar *tsave;
    tsave=gtk_file_selection_get_filename (GTK_FILE_SELECTION (user_data));
    fh=fopen(tsave,"a");
    if(fh!=NULL)
    {
        if (bzvt)
            save=gtk_xtext_get_chars((GtkXText*) text1);
        else
            save=gtk_editable_get_chars( (GtkEditable*) text1,0,-1);

        if(save!=NULL)
            fwrite(save,strlen(save),1,fh);
        fclose(fh);
    }

}

int update()
{
 gchar buf[1024];

 watcher *temp=punta;
 while(temp!=NULL)
 {
     if(temp->fp!=NULL)
     {
         if(fgets(buf,1024,temp->fp))
             if(strlen(buf) > 1) escribir(temp, buf);
     }
     temp=temp->next;
 }
 return 1;
}

void
escribir( watcher *temp, gchar buf[1024])
{
    if(status==TRUE)
    {
        sword *wtemp=temp->word;
        while(wtemp!=NULL)
        {
            if(strstr(buf,wtemp->data)!=NULL)
            {
                if(bxtext)
                { /*poner color*/
                    gtk_xtext_append((GtkXText*) text1,buf,strlen(buf));
                }
                else
                    gtk_text_insert(GTK_TEXT (text1), fixed_font , &temp->color, NULL , buf , -1);
                g_print("buf = %s\n",buf);
                gdk_window_raise(window1->window);
            }
            wtemp=wtemp->next;
        }
    }
}

void
cambiar_state(GtkWidget *item)
{
    item_actual=item;
    item_actual_subtree=GTK_TREE_ITEM_SUBTREE (item);
    que=FALSE;
#ifdef  DEBUG
    g_print("item= %p, item->subtree= %p \n", item, GTK_TREE_ITEM_SUBTREE (item));
#endif
}
void
cambiar_state_word(GtkWidget *item)
{
    item_word=item;
    que=TRUE;
}

//-------------------------------------WIDGET UTILS---------------------
gint
hide_wconfig ()
{
    gtk_widget_hide(GTK_WIDGET(w_config));
    return (TRUE);
}

//----------------------------------TREE FUNCTS---------------------
void
add_watcher_tree( gchar *add_this)
{
    GtkWidget *item, *subtree;

    item = gtk_tree_item_new_with_label (add_this);
    gtk_signal_connect (GTK_OBJECT(item), "select",
                        GTK_SIGNAL_FUNC(cambiar_state), NULL);
    gtk_widget_ref(item);
    gtk_tree_append (GTK_TREE(tree1), item);

    subtree = gtk_tree_new();
    gtk_tree_item_set_subtree (GTK_TREE_ITEM(item), subtree);
    gtk_widget_ref(subtree);
    gtk_widget_show(item);


                                                 
   gtk_tree_item_select(GTK_TREE_ITEM(item));
   gtk_tree_item_expand(GTK_TREE_ITEM(item));

}
void
add_word_tree(gchar *word)
{
    GtkWidget *item,*subtree;

    item = gtk_tree_item_new_with_label(word) ;

    gtk_signal_connect (GTK_OBJECT(item), "select",
                        GTK_SIGNAL_FUNC(cambiar_state_word), NULL);


    if(item_actual_subtree!=NULL)
        gtk_tree_append (GTK_TREE(item_actual_subtree), item);
    else
    {
        subtree = gtk_tree_new();
        gtk_tree_item_set_subtree (GTK_TREE_ITEM(item_actual), subtree);
        gtk_tree_append (GTK_TREE(subtree), item);

        item_actual_subtree=subtree;
    }
    gtk_widget_show(item);

}

void create_tree()
{
    watcher *temp;
    sword   *tword;

    temp=punta;
    while(temp!=NULL)
    {
        GtkWidget *item, *subtree;

        item = gtk_tree_item_new_with_label (temp->path);
        gtk_signal_connect (GTK_OBJECT(item), "select",
                            GTK_SIGNAL_FUNC(cambiar_state), NULL);
        gtk_widget_ref(item);
        gtk_tree_append (GTK_TREE(tree1), item);
        subtree = gtk_tree_new();
        gtk_tree_item_set_subtree (GTK_TREE_ITEM(item), subtree);
        gtk_widget_ref(subtree);

        gtk_widget_show(item);
        gtk_tree_item_expand(GTK_TREE_ITEM(item));


        tword=temp->word;
        while(tword!=NULL)
        {
            GtkWidget *item2;

            item2 = gtk_tree_item_new_with_label(tword->data) ;
            gtk_signal_connect (GTK_OBJECT(item2), "select",
                                GTK_SIGNAL_FUNC(cambiar_state_word), NULL);
            gtk_tree_append (GTK_TREE(subtree), item2);
            gtk_widget_show(item2);
            tword=tword->next;
        }
        temp=temp->next;
    }
}

//----------------------------DATA UTILS FUNCS----------------------------
watcher
*watcher_find( gchar *path)
{
    watcher *tmp=punta;
    while(tmp!=NULL)
    {
        if (strcmp(path,tmp->path)==0)
            return tmp;
        else
            tmp=tmp->next;
    }
return tmp;
}

void
add_word_struct (watcher *donde, gchar *word)
{
    sword *tmp;
    sword *tmp2=NULL;
    tmp=donde->word;

    while(tmp!=NULL)
    {
        tmp2=tmp;
        tmp=tmp->next;
    }

    tmp=g_new0(sword,1);
    tmp->data=g_malloc(strlen(word)+1);
    strcpy(tmp->data,word);
    tmp->next=NULL;

    if(tmp2!=NULL)
        tmp2->next=tmp;
    else
        donde->word=tmp;
}

void watcher_borrar(gchar *name)
{
    watcher *tmp=NULL;
    watcher  *tmp2=punta;
    sword   *tword=NULL;

    while(tmp2!=NULL)
    {
        if(strcmp(name,tmp2->path)==0)
        {
#ifdef  DEBUG
            g_print("Watcher Borrado %s\n",tmp2->path);
#endif
            g_free(tmp2->path);
            tword=tmp2->word;
            while(tword!=NULL)
            {
#ifdef  DEBUG
                g_print("Word Borrada %s\n",tword->data);
#endif
                g_free(tword->data);
                tword=tword->next;
            }
            if(tmp!=NULL)
                    tmp->next=tmp2->next;
             else punta=NULL;

            break;
        }
        tmp=tmp2;
        tmp2=tmp2->next;
    }
}

void
word_borrar(watcher *temp, gchar *name)
{
    sword *tword=NULL;
    sword *tword2;

    
    tword2=temp->word;
    while(tword2!=NULL)
    {
#ifdef  DEBUG
        g_print("Word: %s\n",tword2->data);
#endif
        if(strcmp(tword2->data,name)==0)
        {
#ifdef  DEBUG
            g_print("Borrando word %s\n",tword2->data);
#endif
            g_free(tword2->data);
            if(tword!=NULL)
                tword->next=tword2->next;
            else temp->word=tword2->next;
        }
        tword=tword2;
        if(tword!=NULL)
        tword2=tword2->next;

    }
}

void add_watcher(gchar *name1,gint conta, gpointer **words, GdkColor color)
{
    watcher *temp,*ptr=punta;
    gint i;
    sword *tword,*tword2;


    temp=g_new0(watcher,1);
    temp->path=g_malloc0(strlen(name1)+1);
    strcpy(temp->path,name1);
    temp->path[strlen(temp->path)+1]='\0';
    
    temp->color.red =  color.red;
    temp->color.green = color.green;
    temp->color.blue = color.blue;
    temp->fp=NULL;


    if(punta==NULL) punta=temp;
    else
    {
        while(ptr!=NULL)
            if(ptr->next!=NULL) ptr=ptr->next;
            else break;
        ptr->next=temp;
    }
    temp->next=NULL;

    if(conta==0)
        temp->word=NULL;
    else
    {
        tword=g_new0(sword,1);
        tword->data=g_malloc(strlen((gchar*)&words[0]));
        strcpy(tword->data,(gchar*)&words[0]);

        tword->next=NULL;
        temp->word=tword;


        for(i=1;i<conta;i++)
        {
            tword2=g_new0(sword,1);
            tword2->data=g_malloc(strlen((gchar*)&words[i]));
            strcpy(tword2->data,(gchar*)&words[i]);
            //tword2->data=(gchar*) &words[i];

            tword2->next=NULL;

            tword->next=tword2;
            tword=tword2;
        }
    }
}

//-------------------------------STRINGS FUNCTIONS UTLS------------------------------------------
/*Snarfed from Xchat thanx zed!*/
char *
cfg_get_str (char *cfg, char *var, char *dest)
{
   *dest = 0;
   while (1)
   {
      if (!strncasecmp (var, cfg, strlen (var)))
      {
         char *value, t;
         cfg += strlen (var);
         while (*cfg == ' ' || *cfg == '=')
            cfg++;
         value = cfg;
         while (*cfg != 0 && *cfg != '\n')
            cfg++;
         t = *cfg;
         *cfg = 0;
         strcpy (dest, value);
         *cfg = t;
         return cfg;
      }
      while (*cfg != 0 && *cfg != '\n')
         cfg++;
      if (*cfg == 0)
         return 0;
      cfg++;
      if (*cfg == 0)
         return 0;
   }
}             
unsigned long
cfg_get_int (char *cfg, char *var)
{
   char str[128];
   if (!cfg_get_str (cfg, var, str))
      return 0;
   return atol (str);
}
//--------------------------------CONFIG FILE FUNCTIONS UTILS-------------------------------------
void
save_config()
{

    gchar *filename;
    FILE *cfg;
    watcher *temp=punta;
    sword   *tword;
    gchar  *cchar[2];
    gint   conta=0;
    gint   wcant=0;
    
    filename = g_strconcat(g_get_home_dir(), "/.sportal/config", NULL);
    cfg=fopen(filename,"w+");
    cchar[0]= g_malloc(6);
    cchar[1]= g_malloc(6);
    cchar[2]= g_malloc(6);

    while(temp!=NULL)
    {
        wcant++;
        temp=temp->next;
    }

    fprintf(cfg,"CWatcher = %d\n",wcant);
    temp=punta;
    wcant=0;


    while(temp!=NULL)
    {    wcant++;
         fprintf(cfg,"Watcher[%d] = %s\n",wcant,temp->path);

    /*g_snprintf(cchar[0],6,"%hu",temp->color.red);
         g_snprintf(cchar[1],6,"%hu",temp->color.green);
         g_snprintf(cchar[2],6,"%hu",temp->color.blue);*/

         fprintf(cfg,"Red[%d] = %lu\n",wcant,temp->color.red);
         fprintf(cfg,"Green[%d] = %lu\n",wcant,temp->color.green);
         fprintf(cfg,"Blue[%d] = %lu\n",wcant,temp->color.blue);

         tword=temp->word;
         conta=0;
         while(tword!=NULL)
         {
            conta++;
            tword=tword->next;
         }
         fprintf(cfg,"CWords[%d] = %d\n",wcant,conta);
         tword=temp->word;
         conta=0;
         while(tword!=NULL)
         {
             conta++;
             fprintf(cfg,"Word[%d][%d] = %s\n",wcant,conta,tword->data);
             
             tword=tword->next;
         }
         temp=temp->next;
    }

    fprintf(cfg,"MainWidth = %d\n",w1_ancho);
    fprintf(cfg,"MainHeight = %d\n",w1_altura);
    fprintf(cfg,"MainXpos = %d\n",xw1);
    fprintf(cfg,"MainYpos = %d\n",yw1);

    fprintf(cfg,"ConfigWidth = %d\n",wc_ancho);
    fprintf(cfg,"ConfigHeight = %d\n",wc_altura);
    if(ufont==NULL)
    {
        ufont=g_malloc0(strlen("fixed"));
        strcpy(ufont,"fixed");
    }

    fprintf(cfg,"Font = %s\n",ufont);

    if (bzvt==TRUE)
    {
        fprintf(cfg,"ZVT = %d\n",1);
#ifdef USE_IMLIB
        if(btint==TRUE)
            fprintf(cfg,"Tint = %d\n",1);
        else
            fprintf(cfg,"Tint = %d\n",0);
#endif
/*        g_snprintf(cchar[0],6,"%lu",xcolors[0].red);
        g_snprintf(cchar[1],6,"%lu",xcolors[0].green);
        g_snprintf(cchar[2],6,"%lu",xcolors[0].blue);*/

        fprintf(cfg,"ZVTColor.red = %lu\n", xcolors[0].red);
        fprintf(cfg,"ZVTColor.green = %lu\n",xcolors[0].green);
        fprintf(cfg,"ZVTColor.blue = %lu\n",xcolors[0].blue);
    }
    else
    {
        fprintf(cfg,"ZVT = %d\n",0);
        fprintf(cfg,"Tint = %d\n",0);
    }

    g_free(filename);
    g_free(cchar[0]);
    g_free(cchar[1]);
    g_free(cchar[2]);
}
void
read_config()
{
    gchar *filename;
    struct stat stats;
    int file;
    gchar *data_t;
    gchar *name1;

    gint   cwatchers=0;
    gint   conta=0;
    
    gchar *tag1;
    gchar *sint;
    GdkColor color;

    gpointer **words;
        
    gint   i=0;
    gint   x=0;
    filename = g_strconcat(g_get_home_dir(), "/.sportal/config", NULL);

    file = open(filename, O_RDONLY);
        if (file==-1) return;
    fstat(file, &stats);
    data_t=malloc(stats.st_size);
    read (file, data_t, stats.st_size);

    name1=g_malloc0(255);
    ufont=g_malloc0(255);
    tag1=g_malloc0(255);
    sint=g_malloc0(10);

    cwatchers=cfg_get_int(data_t,"CWatcher ");

    
    for(i=0;i<cwatchers;i++)
    {

        g_snprintf(sint,10,"%d",i+1);
        g_snprintf(tag1,strlen(sint)+10,"Watcher[%d] ",i+1);
        cfg_get_str(data_t,tag1,name1);


        g_snprintf(tag1,strlen(sint)+6,"Red[%d] ",i+1);
//        cfg_get_str(data_t,tag1,color[0]);
         color.red=cfg_get_int(data_t,tag1);

        g_snprintf(tag1,strlen(sint)+8,"Green[%d] ",i+1);
//        cfg_get_str(data_t,tag1,color[1]);
         color.green=cfg_get_int(data_t,tag1);

        g_snprintf(tag1,strlen(sint)+7,"Blue[%d] ",i+1);
//        cfg_get_str(data_t,tag1,color[2]);
         color.blue=cfg_get_int(data_t,tag1);

        g_snprintf(tag1,strlen(sint)+9,"CWords[%d] ",i+1);
        conta=cfg_get_int(data_t,tag1);


        words=g_malloc0(conta);
        for(x=0;x<conta;x++)
        {
            words[x]=g_malloc0(255);
            g_snprintf(tag1,strlen(sint)+9+strlen(sint),"Word[%d][%d] ",i+1,x+1);
            cfg_get_str(data_t,tag1,(char*) &words[x]);

        }
/*        tcolor[0]=atol(color[0]);
        tcolor[1]=atol(color[1]);
        tcolor[2]=atol(color[2]);*/
        add_watcher(name1,conta,words,color);
//        for(x=0;x<conta;x++) g_free(+words[x]);

        //g_free(**words);
    }
   create_tree();

  w1_ancho  =cfg_get_int(data_t,"MainWidth ");
  w1_altura =cfg_get_int(data_t,"MainHeight ");
  xw1       =cfg_get_int(data_t,"MainXpos ");
  yw1       =cfg_get_int(data_t,"MainYpos ");

  wc_ancho  =cfg_get_int(data_t,"ConfigWidth ");
  wc_altura =cfg_get_int(data_t,"ConfigHeight ");

  cfg_get_str(data_t,"Font ",ufont);

  x=cfg_get_int(data_t,"ZVT ");
  if(x==1)
  {
      bzvt=TRUE;
      xcolors[0].red   = cfg_get_int(data_t,"ZVTColor.red ");
      xcolors[0].green = cfg_get_int(data_t,"ZVTColor.green ");
      xcolors[0].blue  = cfg_get_int(data_t,"ZVTColor.blue ");

      gtk_toggle_button_set_active( (GtkToggleButton*) m_check_zvt,TRUE);
      x=cfg_get_int(data_t,"Tint ");
#ifdef USE_IMLIB
      if(x==1)
      {
          btint=TRUE;
          gtk_toggle_button_set_active( (GtkToggleButton*) m_check_tint,TRUE);
      }
      else
      {
          gtk_toggle_button_set_active( (GtkToggleButton*) m_check_tint,FALSE);
          btint=FALSE;
      }
#endif      
  }
  else
  {
      
      btint=FALSE;
#ifdef USE_IMLIB      
      gtk_widget_set_sensitive (m_check_tint, FALSE);
#endif      
      bzvt=FALSE;
      gtk_widget_set_sensitive (m_hbox2, FALSE);
  }



  free(data_t);
  g_free(tag1);
  g_free(sint);
  close(file);
}
